//<editor-fold defaultstate="collapsed" desc=" COPYRIGHT AND LICENSE ">
/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved.
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.geometries.viewer3d.controls.light_editor;

import java.util.ArrayList;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.WindowConstants;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.jogamp.java3d.BoundingSphere;
import org.jogamp.vecmath.Color3f;
import org.visnow.vn.geometries.viewer3d.Display3DPanel;
import org.visnow.vn.geometries.viewer3d.lights.AmbientLightObject;
import org.visnow.vn.geometries.viewer3d.lights.DirectionalLightObject;
import org.visnow.vn.geometries.viewer3d.lights.EditableAmbientLight;
import static org.visnow.vn.geometries.viewer3d.lights.EditableLight.LightType.*;
import org.visnow.vn.geometries.viewer3d.lights.EditablePointLight;
import org.visnow.vn.geometries.viewer3d.lights.LightObject;
import org.visnow.vn.geometries.viewer3d.lights.PointLightObject;
import org.visnow.vn.gui.widgets.SinglePanelColorEditor;

/**
 *
 * @author know
 */
public class LightsEditor extends javax.swing.JPanel
{
    private final Display3DPanel displayPanel;
    private BoundingSphere bounds = null;

    private LightObject selectedLightObject = null;
    private SingleLightEditor selectedEditor = null;
    private final AmbientLightObject ambientLightObject;
    private final ArrayList <SingleLightEditor> editors = new ArrayList<>();
    private final ArrayList <DirectionalLightObject> directionalLightObjects = new ArrayList<>();
    private final ArrayList <PointLightObject> pointLightObjects = new ArrayList<>();
    private final LightTypeEditorPanel directionalLightsEditorPanel = new LightTypeEditorPanel(DIRECTIONAL, this);
    private final LightTypeEditorPanel pointLightsEditorPanel = new LightTypeEditorPanel(POINT, this);

    /**
     * Creates new form LightEditorPanel
     */
    public LightsEditor(Display3DPanel displayPanel)
    {
        initComponents();
        this.displayPanel = displayPanel;
        if (displayPanel != null)
            bounds = displayPanel.getBoundingSphere();
        ambientLightObject =
                new AmbientLightObject(new EditableAmbientLight(bounds, "ambient light"));
        directionalLightsEditorPanel.setBorder(BorderFactory.createTitledBorder("Directional lights"));
        pointLightsEditorPanel.setBorder(BorderFactory.createTitledBorder("Point lights"));
        directionalLightsEditorPanel.setBounds(bounds);
        pointLightsEditorPanel.setBounds(bounds);
        lightTypeEditorsPanel.add(directionalLightsEditorPanel);
        lightTypeEditorsPanel.add(pointLightsEditorPanel);
        SingleLightEditor ambientLightEditor = new SingleLightEditor(ambientLightObject, this);
        editors.add(ambientLightEditor);
        ambientEditorPanel.add(ambientLightEditor);
        lightColorEditor.setVisible(false);
        attenuationEditor.setVisible(false);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        GridBagConstraints gridBagConstraints;

        ambientEditorPanel = new JPanel();
        currentEditorPanel = new JPanel();
        colorEditPanel = new JPanel();
        lightColorEditor = new SinglePanelColorEditor();
        attenuationPanel = new JPanel();
        attenuationEditor = new AttenuationEditor();
        lightTypeEditorsPanel = new JPanel();

        setLayout(new GridBagLayout());

        ambientEditorPanel.setBorder(BorderFactory.createTitledBorder("Ambient light"));
        ambientEditorPanel.setMinimumSize(new Dimension(100, 42));
        ambientEditorPanel.setPreferredSize(new Dimension(100, 42));
        ambientEditorPanel.setLayout(new BorderLayout());
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(ambientEditorPanel, gridBagConstraints);

        currentEditorPanel.setLayout(new GridBagLayout());

        colorEditPanel.setLayout(new BorderLayout());

        lightColorEditor.setMinimumSize(new Dimension(200, 100));
        lightColorEditor.setPreferredSize(new Dimension(255, 130));
        lightColorEditor.addChangeListener(new ChangeListener()
        {
            public void stateChanged(ChangeEvent evt)
            {
                lightColorEditorStateChanged(evt);
            }
        });
        colorEditPanel.add(lightColorEditor, BorderLayout.CENTER);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        currentEditorPanel.add(colorEditPanel, gridBagConstraints);

        attenuationPanel.setMinimumSize(new Dimension(100, 60));
        attenuationPanel.setPreferredSize(new Dimension(200, 65));
        attenuationPanel.setLayout(new BorderLayout());
        attenuationPanel.add(attenuationEditor, BorderLayout.CENTER);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        currentEditorPanel.add(attenuationPanel, gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(currentEditorPanel, gridBagConstraints);

        lightTypeEditorsPanel.setLayout(new GridLayout(2, 0));
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(lightTypeEditorsPanel, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void lightColorEditorStateChanged(ChangeEvent evt)//GEN-FIRST:event_lightColorEditorStateChanged
    {//GEN-HEADEREND:event_lightColorEditorStateChanged
        Color col = lightColorEditor.getColor();
        attenuationEditor.setBasicColor(col);

        if (selectedLightObject != null)
            selectedLightObject.setLightColor(new Color3f(lightColorEditor.getColorComponents()));
        if (selectedEditor != null)
            selectedEditor.updateColor();
    }//GEN-LAST:event_lightColorEditorStateChanged

    public void addEditor(SingleLightEditor editor)
    {
        editors.add(editor);
        LightObject lightObj = editor.getLightObject();
        if (lightObj.getLight().getType() == DIRECTIONAL)
            directionalLightObjects.add((DirectionalLightObject)lightObj);
        else if (lightObj.getLight().getType() == POINT)
            pointLightObjects.add((PointLightObject)lightObj);
        if (displayPanel != null)
            displayPanel.addLightObject(lightObj);
    }

    public void setEdit(SingleLightEditor activeEditor)
    {
        for (SingleLightEditor editor : editors)
            if (editor != activeEditor)
                editor.cleanEdit();
        if (displayPanel != null)
            displayPanel.stopLightTransform();
        selectedEditor = activeEditor;
        selectedLightObject = null;
        if (activeEditor.isSelected()) {
            selectedLightObject = selectedEditor.getLightObject();
            float[] c = new float[3];
            selectedLightObject.getLightColor().get(c);
            Color col = new Color(c[0], c[1], c[2]);
            lightColorEditor.setColor(col);
            lightColorEditor.setVisible(true);
            if (selectedLightObject.getLight().getType() == POINT) {
                attenuationEditor.setLight((PointLightObject)selectedLightObject);
                attenuationEditor.setVisible(true);
            }
            else
                attenuationEditor.setVisible(false);
            if (displayPanel != null)
                displayPanel.transformLight(selectedLightObject);
        }
        else {
            lightColorEditor.setVisible(false);
            attenuationEditor.setVisible(false);
        }
    }

    public void changeEditorDisplay(boolean state)
    {
        if (displayPanel == null)
            return;
        if (state && selectedLightObject != null)
            displayPanel.transformLight(selectedLightObject);
        else
            displayPanel.stopLightTransform();
    }

    public AmbientLightObject getAmbientLightObject()
    {
        return ambientLightObject;
    }

    public ArrayList<DirectionalLightObject> getDirectionalLightObjects()
    {
        return directionalLightObjects;
    }

    public ArrayList<PointLightObject> getPointLightObjects()
    {
        return pointLightObjects;
    }

    public void addBaseDirectionalLight()
    {
        directionalLightsEditorPanel.addLightObject();
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private JPanel ambientEditorPanel;
    private AttenuationEditor attenuationEditor;
    private JPanel attenuationPanel;
    private JPanel colorEditPanel;
    private JPanel currentEditorPanel;
    private SinglePanelColorEditor lightColorEditor;
    private JPanel lightTypeEditorsPanel;
    // End of variables declaration//GEN-END:variables

    public static void main(String[] args)
    {
        JFrame f = new JFrame();
        LightsEditor panel = new LightsEditor(null);
        f.add(panel);
        f.pack();
        f.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        f.setVisible(true);
    }
}
